//
// asn_useful.h - class definitions for ASN.1 module ASN-USEFUL
//
//   This file was generated by snacc on Mon Dec 14 20:25:39 1992
//   UBC snacc by Mike Sample
//   NOTE: this is a machine generated file - editing not recommended
//

#ifndef _asn_useful_h_
#define _asn_useful_h_


// forward declarations

class ObjectDescriptor;
class NumericString;
class PrintableString;
class TeletexString;
class T61String;
class VideotexString;
class IA5String;
class GraphicString;
class VisibleString;
class ISO646String;
class GeneralString;
class UTCTime;
class GeneralizedTime;
class EXTERNALChoice;
class EXTERNAL;

// values defs

 /* [UNIVERSAL 7] IMPLICIT OCTET STRING */
class ObjectDescriptor : public AsnOcts
{
    public:
      ObjectDescriptor(): AsnOcts() {}
      ObjectDescriptor(const char* str): AsnOcts(str) {}
      ObjectDescriptor(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      ObjectDescriptor(const AsnOcts& o): AsnOcts(o) {}
      ObjectDescriptor& operator=(const ObjectDescriptor& o) {ReSet(o); return *this;}
      ObjectDescriptor& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new ObjectDescriptor; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, OD_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, OD_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, OD_TAG_CODE)))
          {
              Asn1Error("ObjectDescriptor::BDec: ERROR - wrong tag\n");
              longjmp(env, -50);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 18] IMPLICIT OCTET STRING */
class NumericString : public AsnOcts
{
    public:
      NumericString(): AsnOcts() {}
      NumericString(const char* str): AsnOcts(str) {}
      NumericString(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      NumericString(const AsnOcts& o): AsnOcts(o) {}
      NumericString& operator=(const NumericString& o) {ReSet(o); return *this;}
      NumericString& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new NumericString; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, NUMERICSTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, NUMERICSTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, NUMERICSTRING_TAG_CODE)))
          {
              Asn1Error("NumericString::BDec: ERROR - wrong tag\n");
              longjmp(env, -51);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 19] IMPLICIT OCTET STRING */
class PrintableString : public AsnOcts
{
    public:
      PrintableString(): AsnOcts() {}
      PrintableString(const char* str): AsnOcts(str) {}
      PrintableString(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      PrintableString(const AsnOcts& o): AsnOcts(o) {}
      PrintableString& operator=(const PrintableString& o) {ReSet(o); return *this;}
      PrintableString& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new PrintableString; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, PRINTABLESTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, PRINTABLESTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, PRINTABLESTRING_TAG_CODE)))
          {
              Asn1Error("PrintableString::BDec: ERROR - wrong tag\n");
              longjmp(env, -52);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 20] IMPLICIT OCTET STRING */
class TeletexString : public AsnOcts
{
    public:
      TeletexString(): AsnOcts() {}
      TeletexString(const char* str): AsnOcts(str) {}
      TeletexString(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      TeletexString(const AsnOcts& o): AsnOcts(o) {}
      TeletexString& operator=(const TeletexString& o) {ReSet(o); return *this;}
      TeletexString& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new TeletexString; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, TELETEXSTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, TELETEXSTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, TELETEXSTRING_TAG_CODE)))
          {
              Asn1Error("TeletexString::BDec: ERROR - wrong tag\n");
              longjmp(env, -53);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 20] IMPLICIT OCTET STRING */
class T61String : public AsnOcts
{
    public:
      T61String(): AsnOcts() {}
      T61String(const char* str): AsnOcts(str) {}
      T61String(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      T61String(const AsnOcts& o): AsnOcts(o) {}
      T61String& operator=(const T61String& o) {ReSet(o); return *this;}
      T61String& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new T61String; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, TELETEXSTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, TELETEXSTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, TELETEXSTRING_TAG_CODE)))
          {
              Asn1Error("T61String::BDec: ERROR - wrong tag\n");
              longjmp(env, -54);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 21] IMPLICIT OCTET STRING */
class VideotexString : public AsnOcts
{
    public:
      VideotexString(): AsnOcts() {}
      VideotexString(const char* str): AsnOcts(str) {}
      VideotexString(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      VideotexString(const AsnOcts& o): AsnOcts(o) {}
      VideotexString& operator=(const VideotexString& o) {ReSet(o); return *this;}
      VideotexString& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new VideotexString; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, VIDEOTEXSTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, VIDEOTEXSTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, VIDEOTEXSTRING_TAG_CODE)))
          {
              Asn1Error("VideotexString::BDec: ERROR - wrong tag\n");
              longjmp(env, -55);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 22] IMPLICIT OCTET STRING */
class IA5String : public AsnOcts
{
    public:
      IA5String(): AsnOcts() {}
      IA5String(const char* str): AsnOcts(str) {}
      IA5String(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      IA5String(const AsnOcts& o): AsnOcts(o) {}
      IA5String& operator=(const IA5String& o) {ReSet(o); return *this;}
      IA5String& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new IA5String; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, IA5STRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, IA5STRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, IA5STRING_TAG_CODE)))
          {
              Asn1Error("IA5String::BDec: ERROR - wrong tag\n");
              longjmp(env, -56);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 25] IMPLICIT OCTET STRING */
class GraphicString : public AsnOcts
{
    public:
      GraphicString(): AsnOcts() {}
      GraphicString(const char* str): AsnOcts(str) {}
      GraphicString(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      GraphicString(const AsnOcts& o): AsnOcts(o) {}
      GraphicString& operator=(const GraphicString& o) {ReSet(o); return *this;}
      GraphicString& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new GraphicString; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, GRAPHICSTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, GRAPHICSTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, GRAPHICSTRING_TAG_CODE)))
          {
              Asn1Error("GraphicString::BDec: ERROR - wrong tag\n");
              longjmp(env, -57);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 26] IMPLICIT OCTET STRING */
class VisibleString : public AsnOcts
{
    public:
      VisibleString(): AsnOcts() {}
      VisibleString(const char* str): AsnOcts(str) {}
      VisibleString(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      VisibleString(const AsnOcts& o): AsnOcts(o) {}
      VisibleString& operator=(const VisibleString& o) {ReSet(o); return *this;}
      VisibleString& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new VisibleString; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, VISIBLESTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, VISIBLESTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, VISIBLESTRING_TAG_CODE)))
          {
              Asn1Error("VisibleString::BDec: ERROR - wrong tag\n");
              longjmp(env, -58);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 26] IMPLICIT OCTET STRING */
class ISO646String : public AsnOcts
{
    public:
      ISO646String(): AsnOcts() {}
      ISO646String(const char* str): AsnOcts(str) {}
      ISO646String(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      ISO646String(const AsnOcts& o): AsnOcts(o) {}
      ISO646String& operator=(const ISO646String& o) {ReSet(o); return *this;}
      ISO646String& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new ISO646String; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, VISIBLESTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, VISIBLESTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, VISIBLESTRING_TAG_CODE)))
          {
              Asn1Error("ISO646String::BDec: ERROR - wrong tag\n");
              longjmp(env, -59);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 27] IMPLICIT OCTET STRING */
class GeneralString : public AsnOcts
{
    public:
      GeneralString(): AsnOcts() {}
      GeneralString(const char* str): AsnOcts(str) {}
      GeneralString(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      GeneralString(const AsnOcts& o): AsnOcts(o) {}
      GeneralString& operator=(const GeneralString& o) {ReSet(o); return *this;}
      GeneralString& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new GeneralString; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, GENERALSTRING_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, GENERALSTRING_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, GENERALSTRING_TAG_CODE)))
          {
              Asn1Error("GeneralString::BDec: ERROR - wrong tag\n");
              longjmp(env, -60);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 23] IMPLICIT OCTET STRING */
class UTCTime : public AsnOcts
{
    public:
      UTCTime(): AsnOcts() {}
      UTCTime(const char* str): AsnOcts(str) {}
      UTCTime(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      UTCTime(const AsnOcts& o): AsnOcts(o) {}
      UTCTime& operator=(const UTCTime& o) {ReSet(o); return *this;}
      UTCTime& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new UTCTime; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, UTCTIME_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, UTCTIME_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, UTCTIME_TAG_CODE)))
          {
              Asn1Error("UTCTime::BDec: ERROR - wrong tag\n");
              longjmp(env, -61);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


 /* [UNIVERSAL 24] IMPLICIT OCTET STRING */
class GeneralizedTime : public AsnOcts
{
    public:
      GeneralizedTime(): AsnOcts() {}
      GeneralizedTime(const char* str): AsnOcts(str) {}
      GeneralizedTime(const char* str, const unsigned long int len): AsnOcts(str,len) {}
      GeneralizedTime(const AsnOcts& o): AsnOcts(o) {}
      GeneralizedTime& operator=(const GeneralizedTime& o) {ReSet(o); return *this;}
      GeneralizedTime& operator=(const char* str) {ReSet(str); return *this;}
      AsnType* Clone() { return new GeneralizedTime; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
    l += BEncDefLen( b, l);
          l += BEncTag1(b, UNIV, PRIM, GENERALIZEDTIME_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;
          AsnLen elmtLen1;

          if ( ((tag = BDecTag(b, bytesDecoded, env)) != 
MAKE_TAG_ID(UNIV, PRIM, GENERALIZEDTIME_TAG_CODE))&&
         (tag != MAKE_TAG_ID(UNIV, CONS, GENERALIZEDTIME_TAG_CODE)))
          {
              Asn1Error("GeneralizedTime::BDec: ERROR - wrong tag\n");
              longjmp(env, -62);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


class EXTERNALChoice : public AsnType
{
    public:
      enum ChoiceIdEnum
      {
           single_ASN1_typeCid = 0,
           octet_alignedCid = 1,
           arbitraryCid = 2
      };

      enum ChoiceIdEnum choiceId;
      union
      {
           AsnOcts* single_ASN1_type;
           AsnOcts* octet_aligned;
           AsnBits* arbitrary;
      };

      EXTERNALChoice() {}
      void Print(ostream& os);
      AsnType* Clone() { return new EXTERNALChoice; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnLen elmtLen;
          AsnTag tag;

          /*  CHOICEs are a special case - grab identifying tag */
          /*  this allows easier handling of nested CHOICEs */
          tag = BDecTag(b, bytesDecoded, env);
          elmtLen = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen, bytesDecoded, env);
      }

      AsnLen BEncContent(BUF_TYPE b);
      void   BDecContent(BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen& bytesDecoded, ENV_TYPE env);

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};


class EXTERNAL : public AsnType
{
    public:
      AsnOid* direct_reference;
      AsnInt* indirect_reference;
      ObjectDescriptor* data_value_descriptor;
      EXTERNALChoice* encoding;

      EXTERNAL()
      {
          /* init optional/default elements to NULL */
          direct_reference = NULL;
          indirect_reference = NULL;
          data_value_descriptor = NULL;
      }

      void Print(ostream& os);
      AsnType* Clone() { return new EXTERNAL; }
      AsnLen BEnc(BUF_TYPE b)
      {
          AsnLen l;
          l = BEncContent(b);
          l += BEncConsLen(b, l);
          l += BEncTag1(b, UNIV, CONS, EXTERNAL_TAG_CODE);
          return(l);
      }

      void BDec(BUF_TYPE b, AsnLen& bytesDecoded, ENV_TYPE env)
      {
          AsnTag tag;
          AsnLen elmtLen1;

          if ( (tag = BDecTag(b, bytesDecoded, env)) != MAKE_TAG_ID(UNIV, CONS, EXTERNAL_TAG_CODE))
          {
              Asn1Error("EXTERNAL::BDec: ERROR - wrong tag\n");
              longjmp(env, -65);
          }
          elmtLen1 = BDecLen(b, bytesDecoded, env);
          BDecContent(b, tag, elmtLen1, bytesDecoded, env);
      }

      AsnLen BEncContent(BUF_TYPE b);
      void   BDecContent(BUF_TYPE b, AsnTag tag, AsnLen elmtLen, AsnLen& bytesDecoded, ENV_TYPE env);

      int BEncPdu( BUF_TYPE b, AsnLen& bytesEncoded)
      {
           bytesEncoded = BEnc(b);
           return(!b.WriteError());
      }

      int BDecPdu( BUF_TYPE b, AsnLen& bytesDecoded)
      {
          ENV_TYPE env;
          int val;

          bytesDecoded = 0;
          if ((val = setjmp(env)) == 0 )
          {
               BDec(b, bytesDecoded, env);
               return(!b.ReadError());
          }
          else
          { cerr << "longjmp return value is " << val << endl;
              return(FALSE);}
      }

};



#endif /* conditional include of asn_useful.h */
