/*
 * sbuf.h
 *
 * Copyright (C) 1993 Michael Sample
 *            and the University of British Columbia
 *
 * This library is free software; you can redistribute it and/or
 * modify it provided that this copyright/license information is retained
 * in original form.
 *
 * If you modify this file, you must clearly indicate your changes.
 *
 * This source code is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */


typedef struct SBuf
{
    char* dataStart;  /* byte last written (or end) */
    char* dataEnd;    /* ptr to first byte after last valid data byte */  
    char* blkStart;   /* ptr to first byte of the buffer */
    char* blkEnd;     /* ptr to first byte past end of the buffer */
    char* readLoc;    /* next byte to read (or end) */     
    int writeError;   /* whether write error occurred */
    int readError;    /* whether read error occurred */
} SBuf;




void PutSBufInGenBuf PROTO((SBuf* sb, GenBuf* gb));
void SBufInit PROTO((SBuf* b, char* data, long int dataLen));
void SBufResetInReadMode PROTO((SBuf* b));
void SBufResetInWriteRvsMode PROTO((SBuf* b));
void SBufInstallData PROTO((SBuf* b , char* data , long int dataLen));
long int SBufDataLen PROTO((SBuf* b));
char* SBufDataPtr PROTO((SBuf* b));
long int SBufBlkLen PROTO((SBuf* b));
char* SBufBlkPtr PROTO((SBuf* b));
int SBufEod PROTO((SBuf* b));
int SBufReadError PROTO((SBuf* b));
int SBufWriteError PROTO((SBuf* b));
void SBufSkip PROTO((SBuf* b, long int skipLen));
void SBufCopy PROTO((char* dst, SBuf* b, long int copyLen));
unsigned char SBufPeekByte PROTO((SBuf* b));
char* SBufPeekSeg PROTO((SBuf* b , long int* lenPtr));
void SBufPeekCopy PROTO((char* dst , SBuf* b , long int copyLen));
char* SBufGetSeg PROTO((SBuf* b ,long int* lenPtr));
void SBufPutSegRvs PROTO((SBuf* b , char* seg , long int segLen));
unsigned char SBufGetByte PROTO((SBuf* b));
void SBufPutByteRvs PROTO((SBuf* b , unsigned char byte));




