/*
 * tbl_incl.h  - wraps all nec tbl stuff in one file 
 *
 * Copyright (C) 1993 Michael Sample
 *            and the University of British Columbia
 *
 * This library is free software; you can redistribute it and/or
 * modify it provided that this copyright/license information is retained
 * in original form.
 *
 * If you modify this file, you must clearly indicate your changes.
 *
 * This source code is distributed in the hope that it will be
 * useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 * of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 */


#include "asn_incl.h"
#include "tbl.h"

typedef void AVal;

typedef AVal* AStructVal;  /* an array of AVal ptrs */

typedef struct AChoiceVal
{
    enum { achoiceval_notused } choiceId;
    AVal* val;
} AChoiceVal;


#include "tbl_util.h"
#include "tbl_enc.h"
#include "tbl_dec.h"
#include "tbl_print.h"
#include "tbl_free.h"

/*
 * TblError(char* str) - configure error handler
 */
#define TblError(str) fprintf(stderr,"%s", str);




